<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <style>
        .aclass{
            list-style: none;
        }
    </style>
</head>
<body>
    <div id="test">
        <input type="text" placeholder="搜索" v-model="searchName">
        <ul>
            <li :class="isA" v-for="(item,index) in filterPerson" :key="index" >
                {{index}} -- {{item.name}} -- {{item.age}}
            </li>
        </ul>
        <ul>
            <li :style="{color:color,fontSize:fontSize + 'px',list_style:list}" v-for="(item,index) in filterPerson" :key="index" >
                {{index}} -- {{item.name}} -- {{item.age}}
            </li>
        </ul>
        <button @click="setType(1)">年龄升序</button>
        <button @click="setType(2)">年龄降序</button>
        <button @click="setType(0)">原本顺序</button>
        
    </div>

    <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
    <script>
        new Vue({
            el:"#test",
            data:{
                searchName: '',
                isA: 'aclass',
                color: 'red',
                orderType: 0, //0原样 1升序 2降序
                fontSize: 30,
                list: 'none',
                person:[
                    {name:'tom',age:20},
                    {name:'waw',age:15},
                    {name:'aa',age:19},
                    {name:'ab',age:20},
                    {name:'kak',age:30},
                    {name:'gag',age:66},
                    {name:'hh',age:88},
                    {name:'ff',age:18}
                ]
            },

            methods:{
                setType(orderType){
                    this.orderType = orderType
                    // return p1,p2
                }

            },

            computed:{
                filterPerson(){

                    // 取出相关数据
                    const {searchName, person, orderType} = this

                    // 最终需要显示的数组
                    let fPerson;

                    // 对person进行过滤
                    fPerson = person.filter(p => p.name.indexOf(searchName)!== -1 )

                    if(orderType !== 0){
                        fPerson.sort(function(p1,p2){
                            // 如果返回负数P1在前，返回正数P2在前
                            // 1升序  2降序
                            if(orderType == 2){
                                return p2.age - p1.age
                            } else{
                                return p1.age - p2.age
                            }

                            
                        })
                    }
                        
                    return fPerson
                }
            }
        })
    </script>
</body>
</html>